#use "fft-staged.ml";;

let fst (x,y) = x;;
let snd (x,y) = y;;

type ('a,'b) arrow = Arr of ('a -> 'b);;

let arr f       = Arr(f);;
let (>>>) af ag = match (af,ag) with (Arr f, Arr g) -> Arr(fun z -> g(f(z)));;
let (&&&) af ag = match (af,ag) with (Arr f, Arr g) -> Arr(fun z -> (f z, g z));;
let even     x  = x*2;;
let odd      x  = x*2+1;;
let omegas   n  = arr (fun x -> (omega (if x<n/2 then x else x-n/2) n) *.. (if x < n/2 then Complex(1.,0.) else Complex(-1.,0.)));;
let dup      n  = arr (fun x -> if x < n then x else x-n);;
let merge    n  = arr (fun x -> match x with ((a,b),c) -> a +.. (b *.. c));;
let (<+>) f g    = fun x -> f(g(x));;

let rec fft  n  input = let n' = n/2 in
                 if n == 1 then arr input
                 else 
                                      ((dup n' >>> fft n' (fun x -> input (x*2)))
                                   &&&
                                       (omegas n)
                                   &&&
                                       (dup n' >>> fft n' (fun x -> input (x*2+1))))
                                                                               >>> merge n;;

(*  correct answer is [(-4., 0.); (2., 2.); (0., 4.); (6., 6.)] *)
let i = 4;;
let sample0 = fun i -> (Complex (float i, float i));;
let f = fft i sample0;;
let g = map (fun x -> match x with (Complex(x,y)) -> (round x, round y)) (map (match f with (Arr f') -> f') (upto 3));;
g;;
