let ( +..) ( (r,s)) ( (t,u)) =  (r+.t, s+.u);;
let ( *..) (r,s) (t,u) = ((r *. t) -. (s *. u), (r *. u) +. (s *. t))
let pi = 4.0 *. atan 1.0;;
let omega j n = let z = 2. *. pi *. ((float j) /. (float n)) in (cos z , sin z)
let rec upto = function 0 -> [] | n -> (n-1)::upto (n-1)
let rec fold f = function (h::t) -> List.fold_right f t h | _ -> raise Not_found;;

let rec fft radix length inputs k =

    let rec butterfly length inputs k slice =
      let continuation inputs = butterfly length (fun i -> inputs (if i*radix/length == slice then (i mod (length/radix)) else i)) k (slice-1)
      in
        if (slice < 0 orelse length/radix < radix)
                then continuation inputs
                else butterfly (length/radix)
                               (fun i -> inputs (i + length * slice / radix))
                               (fun inputs -> continuation (merge (length/radix) inputs))
                               (radix-1)
        
    and merge length inputs i =
      fold (+..) (List.map
                     (fun slice ->
                          (inputs (slice * (length/radix) + (i mod (length/radix))))
                       *..
                          ((omega (slice * (i mod (length/radix))) length)
                       *..
                           (omega (radix * slice * i / length) radix)))
                     (upto radix))

    in butterfly length inputs (fun inputs' -> k (merge length inputs'));;

List.map (fft 2 4 (fun x -> ((float x), (float x))) (fun f -> List.map f (upto 4))) (upto 4);;
